// Shape.h
//
// ICS 65 Fall 2012
// Code Example
//
// Declares the Shape class, an abstract base class for kinds of shapes.

#ifndef SHAPE_H
#define SHAPE_H



class Shape
{
public:
	// Even though there doesn't really need to be a Shape destructor --
	// since Shape only contains a double, which doesn't need any special
	// handling -- I'll declare one here and make it virtual, to establish
	// the fact that Shapes should be destroyed polymorphically.  Once you
	// intend to use inheritance, this is generally a good practice.
	//
	// Notice that this destructor actually has a body -- that's what the
	// curly braces represent.  It's legal to define member function bodies
	// in class declarations in C++, with the compiler and linker promising
	// not to give you any trouble should this header file be included in
	// multiple different source files.  The reason this is allowed is
	// primarily optimization: other source files, knowing what the bodies
	// of functions look like, can perform optimizations such as "inlining"
	// (replacing a function call with the body of the function, which is
	// a great optimization for simple, short functions that take little
	// time relative to the time it takes to set up and tear down the
	// function call).
	virtual ~Shape() { }

	// area() returns the area of this shape.  Since it doesn't need to
	// modify the meaning of the shape in any way.
	virtual double area() const = 0;
};


// Interestingly, since everything in this class is either defined (the
// destructor) or doesn't need to be (the area() function, which is pure
// virtual), we won't need a Shape.cpp.



#endif // SHAPE_H
